summaryrefslogtreecommitdiff
path: root/BaseTools/gcc
diff options
context:
space:
mode:
authorlhauch <lhauch@6f19259b-4bc3-4df7-8a09-765794883524>2007-10-23 17:15:38 +0000
committerlhauch <lhauch@6f19259b-4bc3-4df7-8a09-765794883524>2007-10-23 17:15:38 +0000
commitc47e45a6c257d55ad21d81aa3163c43eb5b99553 (patch)
tree2693e8d3c0b6d3f52b361e7b832947a324297261 /BaseTools/gcc
parent16b5f6819ed3e5e818898fd6a2c1fe64379db876 (diff)
downloadedk2-platforms-c47e45a6c257d55ad21d81aa3163c43eb5b99553.tar.xz
Adding GCC cross-compiler information to BaseTools folder
git-svn-id: https://edk2.svn.sourceforge.net/svnroot/edk2/trunk/edk2@4206 6f19259b-4bc3-4df7-8a09-765794883524
Diffstat (limited to 'BaseTools/gcc')
-rw-r--r--BaseTools/gcc/README.txt35
-rw-r--r--BaseTools/gcc/tianoCross-gcc-4.1145
2 files changed, 180 insertions, 0 deletions
diff --git a/BaseTools/gcc/README.txt b/BaseTools/gcc/README.txt
new file mode 100644
index 0000000000..9e581f2c3e
--- /dev/null
+++ b/BaseTools/gcc/README.txt
@@ -0,0 +1,35 @@
+You may run these scripts to build a Tiano Cross compiler. They have been
+tested on Cygwin, OS X and Linux. You should expect to hack on these scripts to
+make them work on your system. You may need to install additional tools on your
+system to make the scripts work.
+
+You will need
+
+ A recent version (3.0 or later should be fine) of gcc that is able to produce
+ executables for the machine that you want to run this compiler on (the host
+ machine).
+ wget or curl
+ tar
+ bzip
+ gzip
+ bash
+ and possibly others
+
+CYGWIN Notes
+
+You should setup cygwin to use binmode on all mounts. When you initially
+install cygwin it gives you the choice of Unix file mode (recommended) or DOS
+file mode. Unix mode will cause all the cygwin directories to be mounted in
+binmode, while DOS will mount the dirs in textmode. Here is an example of a
+cygwin install where the dirs are (properly) mounted in binmode.
+
+C:\cygwin\bin on /usr/bin type user (binmode)
+C:\cygwin\lib on /usr/lib type user (binmode)
+c:\workspace on /workspace type system (binmode)
+C:\cygwin on / type user (binmode)
+
+If you use textmode, it is likely that the build will fail in a way that is
+hard to debug.
+
+Cygwin is pretty slow, so it is not recommended for large builds.
+
diff --git a/BaseTools/gcc/tianoCross-gcc-4.1 b/BaseTools/gcc/tianoCross-gcc-4.1
new file mode 100644
index 0000000000..bef18436aa
--- /dev/null
+++ b/BaseTools/gcc/tianoCross-gcc-4.1
@@ -0,0 +1,145 @@
+#!/bin/bash
+
+#
+# Get, build and install the latest cross-development tools and libraries
+#
+
+###
+### CYGWIN :: Make sure that cygwin is mouting its file systems in binmode.
+###
+
+#
+# Specify the architectures for which the tools are to be built
+# To build for single target: ARCHS="m68k"
+#
+ARCHS="${ARCHS:-i386}"
+
+# Let's be nice
+renice 10 -p $$
+
+# If any thing goes wrong, we'll bail out.
+set -e
+
+#
+# Specify the versions
+#
+GCC=gcc-4.1.0
+BINUTILS=binutils-2.16.1
+# BINUTILS=binutils-2.16.91-20060119-1
+CYGWIN_SNAP=20060403 # You may need to find a more recent one.
+export PATH=/bin:/usr/bin
+
+#
+# Where to install
+#
+PREFIX="${PREFIX:-/opt/tiano/}"
+
+#
+# Where to get the GNU tools
+#
+BINUTILS_URL=ftp://ftp.ibiblio.org/pub/mirrors/gnu/ftp/gnu/binutils/${BINUTILS}.tar.bz2
+GCC_URL=ftp://mirrors.kernel.org/gnu/gcc/$GCC/$GCC.tar.bz2
+CYG_LOC=http://cygwin.com/snapshots/cygwin-src-${CYGWIN_SNAP}.tar.bz2
+# export http_proxy=http://proxy.dp.intel.com:911
+# export ftp_proxy=http://proxy.dp.intel.com:911
+
+#
+# Uncomment one of the following depending upon which your system provides
+#
+#GET_COMMAND="curl --remote-name"
+GET_COMMAND="wget -nc --no-directories --retr-symlinks "
+
+#
+# Allow environment to override some programs
+#
+MAKE="${MAKE:-make}"
+export MAKE
+SHELL="${SHELL:-/bin/sh}"
+export SHELL
+
+#
+# Get the source
+# If you don't have curl on your machine, try using
+# wget --passive-ftp --no-directories --retr-symlinks <<url>>
+# If that doesn't work, try without the --passive-ftp option.
+#
+getSource() {
+ ${GET_COMMAND} "${BINUTILS_URL}" &
+ ${GET_COMMAND} "${GCC_URL}" &
+ ${GET_COMMAND} "${CYG_LOC}" &
+ wait
+}
+
+#
+# Unpack the source
+#
+unpackSource() {
+ (rm -rf "${BINUTILS}"
+ tar jxf "${BINUTILS}.tar.bz2"
+ ) &
+
+ (rm -rf "${GCC}"
+ tar jxf "${GCC}.tar.bz2"
+ ) &
+
+ (rm -rf cygwin-snapshot-${CYGWIN_SNAP}-1/
+ tar jxf cygwin-src-${CYGWIN_SNAP}.tar.bz2
+ ) &
+
+ wait
+}
+
+CONF_SHELL="${CONF_SHELL:-/bin/bash}"
+# CONF_SHELL="${CONF_SHELL:-echo}"
+
+#
+# Build
+#
+build() {
+ for arch in $ARCHS
+ do (
+ export targ=${arch}-tiano-pe
+ export pref=${PREFIX}${targ}
+ export PATH="${pref}/bin:$PATH"
+
+ ( mkdir -p build-binutils-$targ
+ cd build-binutils-$targ
+ "${CONF_SHELL}" "../${BINUTILS}/configure" \
+ --disable-nls "--target=${targ}" "--prefix=${pref}"
+ ${MAKE} -j1 -w all
+ ${MAKE} -w install
+ ) >> ${targ}.log 2>&1 &&
+
+ (
+ mkdir -p $pref/$targ/sys-include;
+ cp -fr cygwin-snapshot-${CYGWIN_SNAP}-1/newlib/libc/include/* $pref/$targ/sys-include
+ cp -fr cygwin-snapshot-${CYGWIN_SNAP}-1/winsup/cygwin/include/* $pref/$targ/sys-include
+ ) &&
+
+ ( mkdir -p build-gcc-$targ
+ cd build-gcc-$targ
+ "${CONF_SHELL}" "../${GCC}/configure" "--target=${targ}" "--prefix=${pref}" \
+ --with-gnu-as --with-gnu-ld --with-newlib --verbose \
+ --disable-libssp \
+ --disable-nls --enable-languages=c
+ ${MAKE} -j1 -w all
+ ${MAKE} -w install
+ ) >> ${targ}.log 2>&1
+ ) &
+ done
+
+ wait
+}
+
+
+
+#
+# Do everything
+#
+# Comment out any activities you wish to omit
+#
+getSource
+unpackSource
+build
+
+